# Generated by Django 4.2.6 on 2023-10-11 18:43

from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
        ("auth", "0012_alter_user_first_name_max_length"),
        ("individuals", "0001_initial"),
    ]

    operations = [
        migrations.CreateModel(
            name="Case",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "status",
                    models.CharField(
                        choices=[
                            ("new", "New"),
                            ("solved", "Solved"),
                            ("closed", "Closed"),
                        ],
                        default="new",
                        max_length=100,
                    ),
                ),
                ("name", models.CharField(blank=True, max_length=600)),
                ("description", models.TextField(blank=True, null=True)),
                (
                    "case_groups",
                    models.ManyToManyField(
                        blank=True,
                        related_name="case_groups",
                        to="auth.group",
                        verbose_name="Groups of Cases",
                    ),
                ),
                (
                    "cases",
                    models.ManyToManyField(
                        blank=True, related_name="cases", to="individuals.individual"
                    ),
                ),
                (
                    "children",
                    models.ManyToManyField(
                        blank=True, related_name="children", to="individuals.individual"
                    ),
                ),
                (
                    "control_groups",
                    models.ManyToManyField(
                        blank=True,
                        related_name="control_groups",
                        to="auth.group",
                        verbose_name="Groups of Controls",
                    ),
                ),
                (
                    "controls",
                    models.ManyToManyField(
                        blank=True,
                        related_name="controls",
                        to="individuals.individual",
                        verbose_name="Controls",
                    ),
                ),
                (
                    "father",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="father",
                        to="individuals.individual",
                    ),
                ),
                (
                    "mother",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="mother",
                        to="individuals.individual",
                    ),
                ),
                (
                    "shared_with_groups",
                    models.ManyToManyField(
                        blank=True, related_name="shared_with", to="auth.group"
                    ),
                ),
                (
                    "shared_with_users",
                    models.ManyToManyField(
                        blank=True,
                        related_name="shared_with",
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
                (
                    "user",
                    models.ForeignKey(
                        editable=False,
                        on_delete=django.db.models.deletion.CASCADE,
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
            ],
        ),
    ]
