# Generated by Django 4.2.6 on 2023-10-11 18:43

from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion
import individuals.models


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.CreateModel(
            name="ControlGroup",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("name", models.CharField(max_length=600)),
                (
                    "vcf_file",
                    models.FileField(
                        blank=True,
                        help_text="File Format: VCF",
                        max_length=600,
                        upload_to=individuals.models.ControlGroup.get_upload_path,
                    ),
                ),
            ],
        ),
        migrations.CreateModel(
            name="UserGroup",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("name", models.CharField(max_length=600)),
                (
                    "members",
                    models.ManyToManyField(
                        blank=True, related_name="members", to=settings.AUTH_USER_MODEL
                    ),
                ),
            ],
        ),
        migrations.CreateModel(
            name="Individual",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("name", models.CharField(max_length=600)),
                ("is_featured", models.BooleanField(default=True)),
                ("is_public", models.BooleanField(default=False)),
                (
                    "vcf_file",
                    models.FileField(
                        blank=True,
                        help_text="File Format: VCF",
                        max_length=600,
                        upload_to=individuals.models.Individual.get_upload_path,
                    ),
                ),
                ("vcf_header", models.TextField(blank=True, null=True)),
                (
                    "status",
                    models.CharField(blank=True, editable=False, max_length=100),
                ),
                (
                    "n_variants",
                    models.IntegerField(blank=True, editable=False, null=True),
                ),
                ("n_lines", models.IntegerField(blank=True, editable=False, null=True)),
                ("creation_date", models.DateTimeField(auto_now_add=True, null=True)),
                ("modified_date", models.DateTimeField(blank=True, null=True)),
                (
                    "annotation_time",
                    models.CharField(blank=True, max_length=200, null=True),
                ),
                (
                    "insertion_time",
                    models.CharField(blank=True, max_length=200, null=True),
                ),
                (
                    "shared_with_groups",
                    models.ManyToManyField(
                        blank=True,
                        related_name="shared_with_groups",
                        to="individuals.usergroup",
                    ),
                ),
                (
                    "shared_with_users",
                    models.ManyToManyField(
                        blank=True,
                        related_name="shared_with_users",
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
                (
                    "user",
                    models.ForeignKey(
                        editable=False,
                        null=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
            ],
        ),
        migrations.CreateModel(
            name="Group",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("name", models.CharField(max_length=128)),
                (
                    "members",
                    models.ManyToManyField(
                        related_name="group_members", to="individuals.individual"
                    ),
                ),
            ],
        ),
        migrations.CreateModel(
            name="ControlVariant",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("index", models.TextField(db_index=True)),
                (
                    "controlgroup",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to="individuals.controlgroup",
                    ),
                ),
            ],
        ),
    ]
